## freeorion 0.4.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake ${CMAKE_HOME_DIRECTORY}/GG/cmake)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9 CACHE STRING "Set the minimum OSX deployment target version")
set(CMAKE_OSX_ARCHITECTURES i386 CACHE STRING "Set the architecture the universal binaries for OSX should be built for")

set(CMAKE_CONFIGURATION_TYPES Debug Release)
IF(NOT CMAKE_BUILD_TYPE)
  MESSAGE(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF(NOT CMAKE_BUILD_TYPE)

message(STATUS "Build type CMAKE_BUILD_TYPE set to ${CMAKE_BUILD_TYPE}")


##
## Global project configuration
##

project(FreeOrion)

include(GNUInstallDirs)
include(UseCodeCoverage)
include(TargetDependencies)

set(FreeOrion_VERSION 0.4.7)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(BUILD_TESTING "Build the testing tree." OFF)
option(FO_LINK_STATIC_BOOST_LIBS "Link static boost libraries." ${APPLE})


if(BUILD_TESTING)
    message( STATUS "Building Tests")
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(WIN32)
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/..")
    # Search dependency DLLs inside FreeOrionSDK
    target_dependencies_add_search_path("${CMAKE_PREFIX_PATH}/bin")
    set(CMAKE_INSTALL_BINDIR ".")
    set(FreeOrion_INSTALL_LIBDIR ".")
endif()

if(APPLE)
    # Location of the FreeOrionSDK root
    set(CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/Xcode/dep/")
    set(CMAKE_FRAMEWORK_PATH "${CMAKE_SOURCE_DIR}/Xcode/dep/Frameworks")
    set(CMAKE_PROGRAM_PATH "${CMAKE_FRAMEWORK_PATH}/Python.framework/Versions/Current/bin")
endif()

if(UNIX)
    set(FreeOrion_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/freeorion")
endif()

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${FreeOrion_INSTALL_LIBDIR}")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

add_compile_options(
    # Enable (almost) all warnings on compilers
    # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#index-Wall-316
    $<$<CXX_COMPILER_ID:GNU>:-Wall>
    # http://clang.llvm.org/docs/DiagnosticsReference.html#wall
    $<$<CXX_COMPILER_ID:Clang>:-Wall>
    # https://msdn.microsoft.com/en-us/library/thxezb7y.aspx#Anchor_1
    $<$<CXX_COMPILER_ID:MSVC>:/W4>

    # Disable "'<param>': unreferenced formal parameter" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4100>
    # Disable "'<class>::<member>': class '<member-type>' needs to have dll-interface to be used by clients of class '<class>'" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4251>
    # Disable "'<func>': unreferenced local function has been removed" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4505>
    # Disable "declaration of '<type>' hides global declaration" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4459>
    # Disable "function '<func>' marked as __forceinline not inlined" warning
    $<$<CXX_COMPILER_ID:MSVC>:/wd4714>

    # Enable C++ Exception unwind mechanics with DLL support
    $<$<CXX_COMPILER_ID:MSVC>:/EHsc>
)

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Set minimum Windows target version to WindowsXP
        # https://msdn.microsoft.com/en-us/library/aa383745.aspx
        $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=_WIN32_WINNT_WINXP>
        # Default to unicode variants when using Win32 API
        # https://msdn.microsoft.com/en-us/library/dybsewaf.aspx
        $<$<PLATFORM_ID:Windows>:_UNICODE>
        # Disable "'<func>' was declared deprecated" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_SECURE_NO_WARNINGS>
        # Disable '<func>': Function call with parameters that may be unsafe" warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_SCL_SECURE_NO_WARNINGS>
        # Disable '<func>': The POSIX name for this item is deprecated." warning
        # https://msdn.microsoft.com/en-us/library/ttcz0bys.aspx
        $<$<PLATFORM_ID:Windows>:_CRT_NONSTDC_NO_WARNINGS>

        # Define platform specific macros
        $<$<PLATFORM_ID:Windows>:FREEORION_WIN32>
        $<$<PLATFORM_ID:Darwin>:FREEORION_MACOSX>
        $<$<PLATFORM_ID:Linux>:FREEORION_LINUX>
        $<$<PLATFORM_ID:FreeBSD>:FREEORION_FREEBSD>
)

if(WIN32 AND MSVC)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
    set(CMAKE_ARCHIVE_LINKER_FLAGS "${CMAKE_ARCHIVE_LINKER_FLAGS} -stdlib=libc++")
endif()

if(UNIX AND NOT APPLE)
    add_definitions(-DENABLE_BINRELOC)
endif()


##
## Collect project dependencies.
##

set(MINIMUM_PYTHON_VERSION 2.7)
set(MINIMUM_BOOST_VERSION 1.56.0)

find_package(Threads)
find_package(PythonInterp ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(PythonLibs ${MINIMUM_PYTHON_VERSION} REQUIRED)
find_package(Boost ${MINIMUM_BOOST_VERSION}
    COMPONENTS
        date_time
        filesystem
        iostreams
        locale
        log
        regex
        serialization
        python
        signals
        system
        thread
    REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Freetype REQUIRED)
find_package(OpenGL REQUIRED)

if(NOT OPENGL_GLU_FOUND)
    message(FATAL_ERROR "OpenGL GLU library not found.")
endif()

find_package(SDL REQUIRED)
find_package(OpenAL REQUIRED)
find_package(Ogg REQUIRED)
find_package(Vorbis REQUIRED)

if(APPLE)
    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
    find_library(ICONV_LIBRARY iconv)
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

set(BUILD_DEVEL_PACKAGE OFF CACHE INTERNAL "Disables installation of GiGi development files." FORCE)
set(_ORIG_CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
set(CMAKE_INSTALL_LIBDIR "${FreeOrion_INSTALL_LIBDIR}")
add_subdirectory(GG)
set(CMAKE_INSTALL_LIBDIR ${_ORIG_CMAKE_INSTALL_LIBDIR})
unset(_ORIG_CMAKE_INSTALL_LIBDIR)

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS
        # Disable Boost auto-linking
        # http://www.boost.org/doc/libs/1_59_0/libs/config/doc/html/index.html#boost_config.configuring_boost_for_your_platform.user_settable_options
        BOOST_ALL_NO_LINK

        # Boost iostreams doesn't honor BOOST_ALL_NO_LINK when linking zlib.
        # It also tries to link by default to the boost in-source zlib librar,
        # which we don't want.
        # http://www.boost.org/doc/libs/1_59_0/boost/iostreams/detail/config/zlib.hpp
        $<$<PLATFORM_ID:Windows>:BOOST_ZLIB_BINARY=zlib.lib>

        # Link all boost libraries dynamically unless the user requests
        # otherwise.
        # http://www.boost.org/doc/libs/1_59_0/libs/config/doc/html/index.html#boost_config.configuring_boost_for_your_platform.user_settable_options
        $<$<NOT:$<BOOL:${FO_LINK_STATIC_BOOST_LIBS}>>:BOOST_ALL_DYN_LINK>

        # with boost 1.61 some boost::optional internals were changed. However
        # boost::spirit relies on some API the old implementation provided.
        # This define enables the usage of the old boost::optional
        # implementation.  Boost upstream tracks this bug as #12349
        $<$<VERSION_GREATER:${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION},1.60>:BOOST_OPTIONAL_CONFIG_USE_OLD_IMPLEMENTATION_OF_OPTIONAL>

        # We don't need localized output of Boost date_time and not setting
        # the define causes the inclusion of code, which contains std::tolower.
        # This however causes a macro substitutions caused by the libpython
        # headers, which in turn breaks the build.  Python 2.7.13 should have
        # fixed this with python bug #10910
        $<$<PLATFORM_ID:Darwin>:BOOST_DATE_TIME_NO_LOCALE>
        $<$<PLATFORM_ID:FreeBSD>:BOOST_DATE_TIME_NO_LOCALE>
)

link_directories(
    ${Boost_LIBRARY_DIRS}
)


##
## Define main project targets.
##

# To run the version generation every compile we need to deferr the
# execution to a separate target and the existing python command
add_custom_target(freeorionversion
    COMMAND
    "${PYTHON_EXECUTABLE}"
    "${CMAKE_SOURCE_DIR}/cmake/make_versioncpp.py"
    "${CMAKE_SOURCE_DIR}"
    "CMake"
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/util/Version.cpp
    PROPERTIES
    GENERATED TRUE
)


add_library(freeorioncommon "")

if(WIN32)
    set_property(TARGET freeorioncommon
        PROPERTY
        OUTPUT_NAME Common
    )
endif()

target_compile_options(freeorioncommon
    PRIVATE
        $<$<CXX_COMPILER_ID:GNU>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:AppleClang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-ftemplate-depth=512>
        $<$<CXX_COMPILER_ID:AppleClang>:-ftemplate-depth=512>
)

if(APPLE)
    set_target_properties(freeorioncommon
        PROPERTIES
        LINK_FLAGS "-undefined dynamic_lookup"
    )
endif()

target_compile_definitions(freeorioncommon
    PRIVATE
    -DFREEORION_BUILD_COMMON
)

target_include_directories(freeorioncommon SYSTEM
    PRIVATE
        ${CMAKE_SOURCE_DIR}
        ${Boost_INCLUDE_DIRS}
        ${PROJECT_SOURCE_DIR}/GG
        ${ZLIB_INCLUDE_DIRS}
)

target_link_libraries(freeorioncommon
    ${Boost_DATE_TIME_LIBRARY}
    ${Boost_FILESYSTEM_LIBRARY}
    ${Boost_IOSTREAMS_LIBRARY}
    ${Boost_LOG_LIBRARY}
    ${Boost_REGEX_LIBRARY}
    ${Boost_SERIALIZATION_LIBRARY}
    ${Boost_SIGNALS_LIBRARY}
    ${Boost_SYSTEM_LIBRARY}
    ${Boost_THREAD_LIBRARY}
    ${ZLIB_LIBRARIES}
    ${CORE_FOUNDATION_LIBRARY}
)

add_dependencies(freeorioncommon freeorionversion)


add_library(freeorionparseobj OBJECT "")

target_include_directories(freeorionparseobj SYSTEM
    PRIVATE
        ${Boost_INCLUDE_DIRS}
        ${PROJECT_SOURCE_DIR}/GG
)

set_property(TARGET freeorionparseobj
    PROPERTY
    POSITION_INDEPENDENT_CODE ON
)

if(WIN32)
    set_property(TARGET freeorionparse
        PROPERTY
        OUTPUT_NAME Parsers
    )
endif()

target_compile_options(freeorionparseobj
    PRIVATE
        $<$<CXX_COMPILER_ID:GNU>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:AppleClang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-ftemplate-depth=512>
        $<$<CXX_COMPILER_ID:AppleClang>:-ftemplate-depth=512>
        $<$<AND:$<NOT:$<BOOL:${BUILD_TESTING}>>,$<CXX_COMPILER_ID:GNU>>:-O3>
)

target_compile_definitions(freeorionparseobj
    PRIVATE
        -DNDEBUG
        -DFREEORION_BUILD_PARSE
)


add_library(freeorionparse $<TARGET_OBJECTS:freeorionparseobj>)

target_compile_options(freeorionparse
    PRIVATE
        $<$<CXX_COMPILER_ID:GNU>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:Clang>:-fvisibility=hidden>
        $<$<CXX_COMPILER_ID:AppleClang>:-fvisibility=hidden>
)

if(APPLE)
    # Xcode doesn't build freeorionparse because it doesn't have any
    # source code files associated and only links the freeorionparselib
    # objects into a shared library.  Adding an empty file fixes this.
    # https://cmake.org/cmake/help/v3.0/command/add_library.html
    file(WRITE xcode_dummy.cpp "")
    target_sources(freeorionparse
        PRIVATE

=== debian/changelog ===
freeorion (0.4.7-2) unstable; urgency=medium

  * Upload to unstable.
  * Declare compliance with Debian Policy 4.0.0.
  * Use https for Format field.

 -- Markus Koschany <apo@debian.org>  Fri, 23 Jun 2017 23:27:19 +0200

freeorion (0.4.7-1) experimental; urgency=medium

  * New upstream release.
  * Drop all patches. Fixed upstream.
  * Drop deprecated freeorion.menu file.
  * Don't convert and install the xpm icon any more.
  * Update get-orig-source target for new release.
  * Drop build-dependency on imagemagick.
  * Update debian/copyright for the latest release.

 -- Markus Koschany <apo@debian.org>  Sat, 06 May 2017 16:31:25 +0200

=== debian/control ===
Source: freeorion
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 dh-python,
 dpkg-dev (>= 1.17),
 libalut-dev,
 libboost-all-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libglu1-mesa-dev,
 libjpeg-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libsdl2-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 python
Standards-Version: 4.0.0
Homepage: http://www.freeorion.org
Vcs-Git: https://anonscm.debian.org/git/pkg-games/freeorion.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/freeorion.git

Package: freeorion
Architecture: alpha amd64 arm64 armel armhf hppa i386 mips64el powerpc ppc64 ppc64el s390x sparc64 x32
Depends:
 freeorion-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: turn-based space empire and galactic conquest game
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project. FreeOrion is inspired by the
 tradition of the Master of Orion games, but is not a clone or remake of that
 series or any other game.
 .
 The game is about the construction of a living, breathing universe in a grand
 campaign model. You can develop your own galactic empire and explore new star
 systems with your fleets as one of several unique human or alien species.
 Colonization of new worlds, researching new technology, managing your
 resources and defending your planets against the AI or other human players on
 a galactic scale are your main objectives.

Package: freeorion-data
Architecture: all
Depends:
 fonts-dejavu,
 fonts-roboto-unhinted,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 freeorion
Description: turn-based space empire and galactic conquest game -- data
 FreeOrion is a turn-based space empire and galactic conquest (4X) game being
 designed and built by the FreeOrion project.
 .
 This package provides architecture-independent data files for FreeOrion,
 hundreds of unique designs for in-game icons, ships and planets, many
 different sounds and an immersive music score.
 .
 Also included are in-game descriptions, translations and game scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
WEAK_HOSTS := armel armhf

ifneq (,$(findstring $(DEB_HOST_ARCH),$(WEAK_HOSTS)))
	MAX  := 1
	TYPE := MinSizeRel
else
	MAX  := 2
	TYPE := RelWithDebInfo
endif

%:
	dh $@ --max-parallel=$(MAX) --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DOCUMENTATION=off \
		-DBUILD_TUTORIALS=off \
		-DLIB_SUFFIX=/freeorion \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_BUILD_TYPE=$(TYPE)

#workaround for 'dpkg-shlibdeps: error: couldn't find library libGiGi*.so'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/freeorion:$(LD_LIBRARY_PATH)" dh_shlibdeps

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

override_dh_install:
	dh_install --fail-missing
	find debian -type d -empty -delete -printf 'removed %p\n'
	$(RM) -v debian/freeorion-data/usr/share/games/freeorion/default/LICENSE* \
		debian/freeorion-data/usr/share/games/freeorion/default/COPYING \
		debian/freeorion-data/usr/share/games/freeorion/default/data/fonts/LICENSE.*

override_dh_python2:
	dh_python2 -pfreeorion-data /usr/share/games

get-orig-source:
	wget https://github.com/freeorion/freeorion/releases/download/v0.4.7/FreeOrion_v0.4.7_2017-04-24.60d06dc_Source.tar.gz

## freeorion 0.4.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 include(UseCodeCoverage)
 include(TargetDependencies)
 
-set(FreeOrion_VERSION 0.4.7)
+set(FreeOrion_VERSION 0.4.7.1)
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)

=== AI/CMakeLists.txt ===
target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/AIInterface.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/AIInterface.cpp
)

=== Empire/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Diplomacy.h
        ${CMAKE_CURRENT_LIST_DIR}/Empire.h
        ${CMAKE_CURRENT_LIST_DIR}/EmpireManager.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePool.h
        ${CMAKE_CURRENT_LIST_DIR}/Supply.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/Diplomacy.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Empire.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireManager.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePool.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Supply.cpp
)

=== GG/CMakeLists.txt ===
# GG is a GUI for SDL and OpenGL.
#
# Copyright (C) 2009-2011 T. Zach Laine
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA
#
# If you do not wish to comply with the terms of the LGPL please
# contact the author as other terms are available for a fee.
#
# Zach Laine
# whatwasthataddress@gmail.com

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

if(POLICY CMP0044)
    cmake_policy(SET CMP0044 OLD)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake)


##
## Global project configuration
##

project(GiGi)

include(CMakeDependentOption)
include(GNUInstallDirs)
include(UseCodeCoverage)
include(Util)

set(GIGI_VERSION 0.8.0)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(BUILD_SHARED_LIBS "Build project as shared libraries." ON)
option(ENABLE_PNG_TEXTURES "Enable PNG texture support." ON)
option(ENABLE_TIFF_TEXTURES "Enable TIFF texture support." OFF)
option(BUILD_SDL_DRIVER "Builds GG SDL support (the GiGiSDL library)." ON)
option(BUILD_DOCUMENTATION "Builds HTML documentation." OFF)
option(BUILD_TESTING "Build the testing tree." OFF)
option(BUILD_DEVEL_PACKAGE "Install development files." ON)

cmake_dependent_option(USE_STATIC_LIBS "Favour static linking of depencendies." OFF BUILD_SHARED_LIBS OFF)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})


if(MSVC)
    set(CMAKE_STATIC_LIBRARY_PREFIX "lib")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")
    set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /NODEFAULTLIB:LIBCMT")

    add_definitions(/wd4146 /wd4099 /wd4251 /wd4800 /wd4267 /wd4275
                    /wd4244 /wd4101 /wd4258 /wd4351 /wd4996)
    add_definitions(
        /EHsc
        -D_UNICODE
    )
endif()


##
## Collect project dependencies.
##

set(MINIMUM_BOOST_VERSION 1.56.0)

if(NOT USE_STATIC_LIBS)
    add_definitions(
        -DBOOST_ALL_NO_LINK
        -DBOOST_ALL_DYN_LINK
        -DBOOST_LOG_DYN_LINK
    )
endif()

set(Boost_USE_STATIC_LIBS ${USE_STATIC_LIBS})
find_package(Boost ${MINIMUM_BOOST_VERSION} COMPONENTS date_time filesystem regex signals system thread log REQUIRED)

find_package(OpenGL REQUIRED)
find_package(GLEW REQUIRED)
find_package(Freetype REQUIRED)

if(NOT OPENGL_GLU_FOUND)
    message(FATAL_ERROR "OpenGL GLU library not found.")
endif()

if(ENABLE_PNG_TEXTURES)
    find_package(PNG REQUIRED)
    set(int_have_png 1)
else()
    set(int_have_png 0)
endif()

if(ENABLE_TIFF_TEXTURES)
    find_package(TIFF REQUIRED)
    set(int_have_tiff 1)
else()
    set(int_have_tiff 0)
endif()
set(SDL_NO_MAIN true)

find_package(SDL REQUIRED)


include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/GG/Config.h
    @ONLY
)


##
## Define main project targets.
##

add_library(GiGi "")

if(USE_STATIC_LIBS)
    set_target_properties(GiGi
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif()

target_include_directories(GiGi SYSTEM
    PRIVATE
        ${Boost_INCLUDE_DIRS}
        ${OPENGL_INCLUDE_DIR}
        ${GLEW_INCLUDE_DIRS}
        ${FREETYPE_INCLUDE_DIRS}
        ${PNG_INCLUDE_DIRS}
        ${TIFF_INCLUDE_DIRS}
)

target_link_libraries(GiGi
    ${Boost_LIBRARIES}
    ${OPENGL_LIBRARIES}
    ${GLEW_LIBRARIES}
    ${FREETYPE_LIBRARIES}
)

if(PNG_FOUND)
    target_link_libraries(GiGi ${PNG_LIBRARIES})
endif()

if(TIFF_FOUND)
    target_link_libraries(GiGi ${TIFF_LIBRARIES})
endif()


add_library(GiGiSDL "")

if(USE_STATIC_LIBS)
    set_target_properties(GiGiSDL
        PROPERTIES
        LINK_SEARCH_END_STATIC true
    )
endif()

target_include_directories(GiGiSDL SYSTEM
    PRIVATE
        ${Boost_INCLUDE_DIRS}
        ${OPENGL_INCLUDE_DIR}
        ${GLEW_INCLUDE_DIRS}
        ${SDL_INCLUDE_DIRS}
)

target_link_libraries(GiGiSDL
    GiGi
    ${OPENGL_LIBRARIES}
    ${GLEW_LIBRARIES}
    ${SDL_LIBRARIES}
)


##
## Recurse into sources.
##

add_subdirectory(GG)
add_subdirectory(src)

if(BUILD_TESTING)
    enable_testing()
    enable_coverage()

    if(NOT TARGET unittest)
        add_custom_target(unittest
            COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
            COMMENT "Run tests for ${CMAKE_PROJECT_NAME}"
        )
    endif()

    add_subdirectory(test)
endif()

if(BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()


##
## Install targets and package project.
##

if(BUILD_DEVEL_PACKAGE)
    install(
        DIRECTORY GG
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        COMPONENT COMPONENT_GIGI_DEVEL
    )
endif()

install(
    TARGETS GiGi
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT COMPONENT_GIGI
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_GIGI
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT COMPONENT_GIGI_DEVEL
)

if(UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGi_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/GiGi.pc.in
        ${CMAKE_BINARY_DIR}/GiGi.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGi.pc
        DESTINATION  ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif()


install(
    TARGETS GiGiSDL
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT COMPONENT_GIGISDL
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT COMPONENT_GIGISDL
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT COMPONENT_GIGISDL_DEVEL
)

if(UNIX AND BUILD_DEVEL_PACKAGE)
    get_pkg_config_libs(pkg_config_libs ${GiGiSDL_LINK_LIBS})

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/cmake/GiGiSDL.pc.in
        ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        @ONLY
    )

    install(
        FILES ${CMAKE_BINARY_DIR}/GiGiSDL.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        COMPONENT COMPONENT_GIGI_DEVEL
        OPTIONAL
    )
endif()


set(CPACK_PACKAGE_VERSION ${GIGI_VERSION})
set(CPACK_PACKAGE_VENDOR "T. Zachary Laine")
set(CPACK_PACKAGE_CONTACT ${CPACK_PACKAGE_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A C++ OpenGL GUI library.")
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/COPYING)
set(CPACK_SYSTEM_NAME ${CMAKE_SYSTEM_NAME})
set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-src)

# RPM-specific settings
set(CPACK_RPM_PACKAGE_LICENSE LGPL)
set(CPACK_RPM_PACKAGE_REQUIRES)

list(APPEND CPACK_RPM_PACKAGE_REQUIRES Mesa freetype2)
list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi=${GIGI_VERSION})

if(BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL>=1.2)
endif()

if(BUILD_DEVEL_PACKAGE)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES boost-devel>=1.44.0 Mesa-devel freetype2-devel)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES gigi-devel=${GIGI_VERSION})
endif()

if(BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    list(APPEND CPACK_RPM_PACKAGE_REQUIRES SDL-devel>=1.2)
endif()

# Deb-specific settings
set(CPACK_DEBIAN_PACKAGE_SECTION libs)

set(CPACK_DEBIAN_PACKAGE_DEPENDS "libgl1-mesa-glx | libgl1, libglu1-mesa | libglu, libfreetype6")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi (= ${GIGI_VERSION})")

if(BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2debian (>= 1.2)")
endif()

if(BUILD_DEVEL_PACKAGE)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "boost-devel (>= 1.44.0), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libfreetype6-dev")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, gigi-dev (= ${GIGI_VERSION})")
endif()

if(BUILD_DEVEL_PACKAGE AND BUILD_SDL_DRIVER)
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsdl1.2-dev (>= 1.2)")
endif()

if(UNIX)
    set(CPACK_GENERATOR "TGZ;TBZ2")
    find_program(RPMBUILD rpmbuild)
    if(RPMBUILD)
        list(APPEND CPACK_GENERATOR RPM)
    endif()
    set(RPMBUILD ${RPMBUILD} CACHE INTERNAL "")
    find_program(DPKG dpkg)
    if(DPKG)
        list(APPEND CPACK_GENERATOR DEB)
    endif()
    set(DPKG ${DPKG} CACHE INTERNAL "")
    set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
elseif(WIN32)
    set(CPACK_GENERATOR "NSIS")
    set(CPACK_SOURCE_GENERATOR "ZIP")
endif()

include(CPack)

cpack_add_component(
    COMPONENT_GIGI
    DISPLAY_NAME GiGi
    DESCRIPTION "The core GG library, including the GUI state machine and all the controls.  Not usable without an input driver."
    REQUIRED
    GROUP COMPONENT_GROUP_RUNTIME
)

cpack_add_component(
    COMPONENT_GIGISDL
    DISPLAY_NAME GiGiSDL
    DESCRIPTION "An SDL input driver (http://www.libsdl.org)."
    GROUP COMPONENT_GROUP_RUNTIME
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGI_DEVEL
    DISPLAY_NAME "GiGi"
    DESCRIPTION "The files necessary to do development with GiGi."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI
)

cpack_add_component(
    COMPONENT_GIGISDL_DEVEL
    DISPLAY_NAME "GiGiSDL"
    DESCRIPTION "The files necessary to do development with GiGiSDL."
    GROUP COMPONENT_GROUP_DEVEL
    DEPENDS COMPONENT_GIGI_DEVEL COMPONENT_GIGISDL
)

cpack_add_component_group(
    COMPONENT_GROUP_RUNTIME
    DISPLAY_NAME "Runtime"
    DESCRIPTION "The runtime libs needed to run an application that uses GG."
    EXPANDED
)

cpack_add_component_group(
    COMPONENT_GROUP_DEVEL
    DISPLAY_NAME "Development"
    DESCRIPTION "The development libs and headers needed to build an application that uses GG."
    EXPANDED
)

=== UI/CMakeLists.txt ===
add_subdirectory(CombatReport)

target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/About.h
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.h
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISlider.h
        ${CMAKE_CURRENT_LIST_DIR}/CUISpin.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.h
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.h
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.h
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.h
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.h
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.h
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.h
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.h
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.h
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.h
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesignPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/Sound.h
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.h
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.h
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.h
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/About.cpp
        ${CMAKE_CURRENT_LIST_DIR}/AccordionPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildDesignatorWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CensusBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ChatWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientUI.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatLogWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportData.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/CombatReportWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatReport/GraphicalSummary.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIControls.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIDrawUtil.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUILinkTextBlock.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIStyle.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CUIWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DesignWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaDetailPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetButton.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GalaxySetupWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/GraphControl.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Hotkeys.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IconTextBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/InGameMenu.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntroScreen.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LinkText.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MapWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MeterBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MilitaryPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ModeratorActionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiIconValueIndicator.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiMeterStatusBar.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MultiplayerLobbyWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ObjectListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/OptionsWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlayerListWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PopulationPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ProductionWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/QueueListBox.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResearchWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourceBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ResourcePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveFileDialog.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerConnectWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShaderProgram.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesignPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SidePanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SitRepPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Sound.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsPanel.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemIcon.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SystemResourceSummaryBrowseWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeArcs.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeLayout.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechTreeWnd.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TextBrowseWnd.cpp
)

=== client/CMakeLists.txt ===
add_subdirectory(AI)
add_subdirectory(human)

target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
)

target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.h
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ClientFSMEvents.cpp
)

=== combat/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/CombatEvent.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatEvents.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatLogManager.h
        ${CMAKE_CURRENT_LIST_DIR}/CombatSystem.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CombatEvent.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatEvents.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CombatLogManager.cpp
)

target_sources(freeoriond
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CombatSystem.cpp
)

target_sources(freeorionca
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CombatSystem.cpp
)

target_sources(freeorion
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CombatSystem.cpp
)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

if(DOXYGEN_FOUND)
    set(FreeOrion_CPP_APIDOC_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/cpp-apidoc)

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY
    )

    if(NOT TARGET doc)
        add_custom_target(doc)
    endif()

    add_custom_target(cpp-apidoc
        ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tag_parser.py --template ${CMAKE_CURRENT_SOURCE_DIR}/all_tags.dox.in --match ${FreeOrion_SOURCE_DIR}/default -f "*.py" "*.focs.txt" "*.macros" -o ${FreeOrion_CPP_APIDOC_OUTDIR}/all_tags.dox --link_source ${FreeOrion_SOURCE_DIR} "https://github.com/freeorion/freeorion/blob/master/" "#L" &&
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${FreeOrion_SOURCE_DIR}
        COMMENT "Generating FreeOrion API documentation with Doxygen" VERBATIM
    )

    add_dependencies(doc cpp-apidoc)
endif()

=== network/CMakeLists.txt ===
target_sources(freeorioncommon
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Message.h
        ${CMAKE_CURRENT_LIST_DIR}/MessageQueue.h
        ${CMAKE_CURRENT_LIST_DIR}/Networking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/Message.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MessageQueue.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Networking.cpp
)

target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ServerNetworking.cpp
)

target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
)

target_sources(freeorion
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/ClientNetworking.cpp
)

=== parse/CMakeLists.txt ===
target_sources(freeorionparseobj
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/Parse.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CommonParams.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.h
        ${CMAKE_CURRENT_LIST_DIR}/EffectParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.h
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.h
        ${CMAKE_CURRENT_LIST_DIR}/ParseImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.h
        ${CMAKE_CURRENT_LIST_DIR}/Tokens.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParser.h
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParserImpl.h
        ${CMAKE_CURRENT_LIST_DIR}/AlignmentsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/BuildingsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/CommonParamsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser6.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser7.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ConditionParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/DoubleValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser1.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser2.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser3.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser4.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser5.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EffectParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireStatsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EncyclopediaParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EnumParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FieldsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/FleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/IntValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ItemsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/KeymapParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Lexer.cpp
        ${CMAKE_CURRENT_LIST_DIR}/MonsterFleetPlansParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Parse.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetEnvironmentValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetSizeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/PlanetTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ReportParseError.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipDesignsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipHullsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ShipPartsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpecialsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SpeciesParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StarTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringComplexValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/StringValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/TechsParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/Tokens.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseObjectTypeValueRefParser.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ValueRefParserImpl.cpp
)

=== python/CMakeLists.txt ===
add_subdirectory(AI)
add_subdirectory(server)

target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/CommonFramework.h
        ${CMAKE_CURRENT_LIST_DIR}/CommonWrappers.h
        ${CMAKE_CURRENT_LIST_DIR}/SetWrapper.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CommonFramework.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EnumWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LoggingWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseWrapper.cpp
)

target_sources(freeorionca
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/CommonFramework.h
        ${CMAKE_CURRENT_LIST_DIR}/CommonWrappers.h
        ${CMAKE_CURRENT_LIST_DIR}/SetWrapper.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/CommonFramework.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EmpireWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/EnumWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/LoggingWrapper.cpp
        ${CMAKE_CURRENT_LIST_DIR}/UniverseWrapper.cpp
)

=== server/CMakeLists.txt ===
target_sources(freeoriond
    PUBLIC
        ${CMAKE_CURRENT_LIST_DIR}/SaveLoad.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerApp.h
        ${CMAKE_CURRENT_LIST_DIR}/ServerFSM.h
    PRIVATE
        ${CMAKE_CURRENT_LIST_DIR}/dmain.cpp
        ${CMAKE_CURRENT_LIST_DIR}/SaveLoad.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerApp.cpp
        ${CMAKE_CURRENT_LIST_DIR}/ServerFSM.cpp
)

=== debian/changelog ===
freeorion (0.4.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Declare compliance with Debian Policy 4.1.0.

 -- Markus Koschany <apo@debian.org>  Thu, 14 Sep 2017 08:29:04 +0200

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
  libvorbis-dev,
  pkg-config,
  python
-Standards-Version: 4.0.0
+Standards-Version: 4.1.0
 Homepage: http://www.freeorion.org
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/freeorion.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/freeorion.git

=== debian/rules ===
--- 
+++ 
@@ -42,5 +42,5 @@
 	dh_python2 -pfreeorion-data /usr/share/games
 
 get-orig-source:
-	wget https://github.com/freeorion/freeorion/releases/download/v0.4.7/FreeOrion_v0.4.7_2017-04-24.60d06dc_Source.tar.gz
+	wget https://github.com/freeorion/freeorion/releases/download/v0.4.7.1/FreeOrion_v0.4.7.1_2017-09-03.139ffd9_Source.tar.gz
